/*
This script contains other engine functions which are used
directly for things like in-game battles and cutscenes.
*/

/*
/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
map functions to add:

***Regular Map Engine***
-LoadMap => Cubes, sprites, tilesets, etc.
-CenterCamera
-GetYPoint/GetXPoint
-SetCameraX/SetCameraY
-RotateCamera(radians)
-RotateToAngle(radian)
-ClearQueue("draw"/"action")

-RotateToCube(radian)
****IMPORTANT****
the above function MUST rotate the camera so that the cube is visible
as well as shift the camera X and Y values so that it is centered.
*/


 /*-------------------------*\
|															|
|			Engine Functions				|
|															|
 \*-------------------------*/

var LastFrameTime = 0;
var DrawQueue = new Array();
var ActionQueue = new Array();
var FrameSec = 1000/60;
var TheFrames = 0;
var Foreground = true;
var Advancing = false;

var DrawIndex = new Array();
var TheString = "";

function StandardView()
{
	x_a_start = 3.14159/4;
	x_angle = 3.14159/4;
	y_angle = -3.14159/4;
	TiltAmount = 1;
	CDir = "d1";
	CameraX=-150;
	CameraY= -94;
	Scale = .75;
	RearrangeAngle();
}

var ExitMapEngine = false;
//the main map function

var SkipRate = 1.80;

function NextFrame(input, autocenter)
{

	if (input == undefined)
	{
	input = true;
	}
var CurrentTime = 0;
var StringChar = 0;
ExitMapEngine = false;

	if (autocenter == true || autocenter == undefined)
	{
	x_a_start = 3.14159/4;
	x_angle = 3.14159/4;
	y_angle = -3.14159/4;
	CDir = "d1";
	CameraX=-150;
	CameraY= -94;
	Scale = .75;
	RearrangeAngle();
	}
	
	while(true)
	{
		CurrentTime = GetTime();

		if (CurrentTime-LastFrameTime > FrameSec)
		{
			for (fci5=0; fci5<FrameSec; fci5+= (CurrentTime-LastFrameTime))
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}

			Frames++;
			TheFrames++;
				if (ActionQueue[TheFrames] != undefined && ActionQueue[TheFrames] != "")
				{
					DoScript(ActionQueue[TheFrames]);
					ActionQueue[TheFrames] = undefined;
				}
				
				if (CurrentTime-LastFrameTime <= 0)
				{
						CurrentTime = GetTime();
						fci5 = FrameSec;
				}
			}
		LastFrameTime = CurrentTime;
		}

		//Draw this frame
			DrawMap();

			if (DrawQueue[TheFrames] != undefined && DrawQueue[TheFrames] != "")
			{
			DoScript(DrawQueue[TheFrames]);
			DrawQueue[TheFrames-1] = undefined;
			}
			if (Foreground == true)
			{
			DrawForeground();
			}
			
			FlipScreen();

			if (Foreground == true)
			{
				if (tempy2 == Math.floor(tempy2))
				{
					for (df1 = 0; df1 < LetterSkip; df1++)
					{
					TheString += Texts[CurrentText].charAt(tempy2*LetterSkip + df1);
					}
				}
				tempy2++;		
			}

		if (ExitMapEngine == true)
		{
		ExitMapEngine = false;
		return;
		}
		//check keyinputs
		if (TheFrames/4 == Math.floor(TheFrames/4) && input == true)
		{
			if (IsKeyPressed(KEY_ESCAPE))
			{
	//		GetKey();
	//		return;
			}
			if (IsKeyPressed(KEY_A))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
		
				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale+= .05;

				if (Scale == 0)
				{
				Scale = 0.01;
				}

				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Z))
			{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);

				ModX_x=ModX_x/Scale;
				ModX_y=ModX_y/Scale;
				ModY_x=ModY_x/Scale;
				ModY_y=ModY_y/Scale;
				Scale-= .05;
				if (Scale <= 0)
				{
				Scale = 0.01;
				}
	
				ModX_x=ModX_x*Scale;
				ModX_y=ModX_y*Scale;
				ModY_x=ModY_x*Scale;
				ModY_y=ModY_y*Scale;
				ModZ_y=-1*ZFactor*Scale;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
			}
			if (IsKeyPressed(KEY_Q))
			{
				x_angle+= .1;
				y_angle+= .1;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_W))
			{
				x_angle-= .1;
				y_angle-= .1;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_D))
			{
				x_a_start += 3.1141569/180
				y_angle-=3.141569/180;
				x_angle+=3.141569/180;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_C))
			{
				x_a_start -= 3.1141569/180
				y_angle+=3.141569/180;
				x_angle-=3.141569/180;
				RearrangeAngle();
			}
			if (IsKeyPressed(KEY_DOWN))
			{
				CameraY+= 8;
			}
			if (IsKeyPressed(KEY_UP))
			{
				CameraY-= 8;
			}
			if (IsKeyPressed(KEY_RIGHT))
			{
				CameraX+= 8;
			}
			if (IsKeyPressed(KEY_LEFT))
			{
				CameraX-= 8;
			}
			if (IsKeyPressed(KEY_SPACE))//Sets the camera to the default position
			{
				x_a_start = 3.14159/4;
				x_angle = 3.14159/4;
				y_angle = -3.14159/4;
				CDir = "d1";
				CameraX=-150;
				CameraY= -94;
				Scale = .75;
				RearrangeAngle();
			}
		}
	
		if (input == true)
		{
			while (AreKeysLeft())
			{
				if (GetKey() == KEY_ESCAPE)
				{
					EngineMenu();
				}
			}
		}

		if (Advancing == true)
		{
		AdvancingFunc();
		}

	}
}


function AdvancingFunc()
{
}


function ExitEngine()
{
ExitMapEngine = true;
} 

function SetMapDelayScript(frames, type, script)
{
//	if (frames == 0)
//		frames++;
	
	if (type == "draw")
	{
		if (DrawQueue[TheFrames+frames] != undefined)
		{
		DrawQueue[TheFrames+frames] += script;
		}
		else
		{
		DrawQueue[TheFrames+frames] = script;
		}
	}
	else
	{
		if (ActionQueue[TheFrames+frames] != undefined)
		{
		ActionQueue[TheFrames+frames] += script
		}
		else
		{
		ActionQueue[TheFrames+frames] = script;
		}
	}
}

var Window = LoadWindowStyle("main.rws");
var Port1 = LoadImage("Sprite1.png");

function DoScript(string)
{
//var temp = CreateStringFromCode(47);
//var tempf = OpenFile(".." + temp + "other" + temp + "temp.js");

//tempf.write("/*", "*/"+string);
//tempf.flush();
//EvaluateScript('..' + temp + 'other' + temp + 'temp.js');
eval(string);
}

var tempy2 = 0;
var ForegroundBasic = false;
var TheString2 = "";

var LetterSkip = 2;







function SetScale(num)
{
	Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
	Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
	Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
		
	ModX_x=ModX_x/(ScaleBase*Scale);
	ModX_y=ModX_y/(ScaleBase*Scale);
	ModY_x=ModY_x/(ScaleBase*Scale);
	ModY_y=ModY_y/(ScaleBase*Scale);
	Scale= num;

	if (Scale <= 0)
	{
	Scale = 0.01;
	}

	ModX_x=ModX_x*ScaleBase*Scale;
	ModX_y=ModX_y*ScaleBase*Scale;
	ModY_x=ModY_x*ScaleBase*Scale;
	ModY_y=ModY_y*ScaleBase*Scale;
	ModZ_y=-1*ZFactor*ScaleBase*Scale;
	CenterCamera(Cameratempx, Cameratempy, Cameratempz);
}

function RotateCamera(rads, queue, center, x,y,z,frames)
{
LastFrameTime = 0;
	if (rads <0)
	{
	var boo = false;
	}
	else
	{
	var boo = true;
	}

	if (frames!= undefined)
	{
	frames = 0.05;
	}
	else
	{
	frames = rads/frames;
	}

	var counter = 0;

	if (queue == false || queue == undefined)
	{
		while(true)
		{
		CurrentTime = GetTime();

			if (CurrentTime-LastFrameTime > FrameSec)
			{
				for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
				{
					if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
					{
					AddFrameAll();
					}
				Frames++;
				}
			LastFrameTime = CurrentTime;
			}
				if (boo == true)
				{
					if (rads>=0)
						rads -= frames;
					else
						break;

					x_angle+= frames;
					y_angle+= frames;
					RearrangeAngle();
				}
				else
				{
					if (rads<=0)
						rads += frames;
					else
						break;

					x_angle-= frames;
					y_angle-= frames;
					RearrangeAngle();
				}

			if (center == true || center == undefined)
			{
			CenterCamera(x,y,z);
			}


				DrawMap();
				FlipScreen();
		}
	}
	else
	{
		while(true)
		{
			if (boo == true)
			{
				if (rads>=0)
					rads -= frames;
				else
					break;

				SetMapDelayScript(counter, "action", "x_angle+= "+frames+"; y_angle+= "+frames+"; RearrangeAngle();");

				if (center == true || center == undefined)
				{
				SetMapDelayScript(counter, "action", "CenterCamera("+ x + "," + y + "," + z+");");
				}
			}
			else
			{
				if (rads<=0)
					rads += frames;
				else
					break;

				SetMapDelayScript(counter, "action", "x_angle-= "+frames+"; y_angle-= "+frames+"; RearrangeAngle();");
				
				if (center == true || center == undefined)
				{
				SetMapDelayScript(counter, "action", "CenterCamera("+ x + "," + y + "," + z+");");
				}
			}
		counter++;
		}
	}
}

function CenterCameraTo(x,y,z, queue, speed)
{
//Center to the sprite
var CurrentTime = 0;
var temp_x = (ModX_x*(x) + ModY_x*(y))*TileSize-CameraX-GetScreenWidth()/2;
var temp_y = (ModX_y*(x) + ModY_y*(y) + ModZ_y*(z))*TileSize - CameraY - GetScreenHeight()/2;
LastFrameTime = 0;
/*
//This was used for debugging

DrawMap();
Line(GetScreenWidth()/2, GetScreenHeight()/2, GetScreenWidth()/2+temp_x, GetScreenHeight()/2+temp_y, CreateColor(0,0,255,255));
//Line(100, 100, 100+temp_x, 100, CreateColor(0,0,255,255));
//Line(100, 100, 100, 100+temp_y, CreateColor(0,0,255,255));
//Line(50+temp_x-GetScreenWidth()/2, 50, 50+temp_x-GetScreenWidth()/2, -temp_y+GetScreenHeight()/2, CreateColor(0,0,255,255));
Point(temp_x+GetScreenWidth()/2, temp_y+GetScreenHeight()/2, CreateColor(255,255,255,255));
FlipScreen();
GetKey();
*/

	if (speed == undefined)
	{
	speed = 3;
	}
	speed *= ScaleBase;

var temp4 = Math.sqrt(temp_x*temp_x + temp_y*temp_y)/speed;

	if (temp4==0)
		return;

var temp_x = temp_x/temp4;
var temp_y = temp_y/temp4;


	if (queue == false || queue == undefined)
	{
		while(true)
		{
			CurrentTime = GetTime();

			if (CurrentTime-LastFrameTime > FrameSec)
			{
				for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
				{
					if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
					{
					AddFrameAll();
					}
				Frames++;
				}
			LastFrameTime = CurrentTime;
			}

				//now use temp4 as a counter
				if (temp4>=0)
					temp4--;
				else
					break;

				CameraX+=temp_x;
				CameraY+=temp_y;

				DrawMap();
				FlipScreen();
		}
	CenterCamera(x, y, z);
	}
	else //queue this into the engine
	{
		for (i=0; i<= temp4; i++)
		{
		SetMapDelayScript(i, "action", "CameraX+="+temp_x+"; CameraY+="+temp_y+";");
		} 
		SetMapDelayScript(Math.floor(temp4)+1, "action", "CenterCamera("+x+","+y+","+z+");");
	}
}

function CenterCameraToV2(x,y,z, x2,y2,z2,queue, speed, rads)
{
//Center to the sprite
var CurrentTime = 0;
LastFrameTime = 0;
//var temp_x = (ModX_x*(x) + ModY_x*(y))*TileSize-CameraX-GetScreenWidth()/2;
//var temp_y = (ModX_y*(x) + ModY_y*(y) + ModZ_y*(z))*TileSize - CameraY - GetScreenHeight()/2;

var temp_x= x2-x;
var temp_y= y2-y;
var temp_z= z2-z;

/*
//This was used for debugging

DrawMap();
Line(GetScreenWidth()/2, GetScreenHeight()/2, GetScreenWidth()/2+temp_x, GetScreenHeight()/2+temp_y, CreateColor(0,0,255,255));
//Line(100, 100, 100+temp_x, 100, CreateColor(0,0,255,255));
//Line(100, 100, 100, 100+temp_y, CreateColor(0,0,255,255));
//Line(50+temp_x-GetScreenWidth()/2, 50, 50+temp_x-GetScreenWidth()/2, -temp_y+GetScreenHeight()/2, CreateColor(0,0,255,255));
Point(temp_x+GetScreenWidth()/2, temp_y+GetScreenHeight()/2, CreateColor(255,255,255,255));
FlipScreen();
GetKey();
*/

	if (speed == undefined)
	{
	speed = 3;
	}

var temp4 = TileSize*Math.sqrt(temp_x*temp_x + temp_y*temp_y + temp_z*temp_z)/speed;

	if (temp4==0)
		return;

var temp_x = temp_x/(temp4);
var temp_y = temp_y/(temp4);
var temp_z = temp_z/(temp4);

var Vi= 0;
	if (queue == false || queue == undefined)
	{
		while(true)
		{
			CurrentTime = GetTime();

			if (CurrentTime-LastFrameTime > FrameSec)
			{
				for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
				{
					if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
					{
					AddFrameAll();
					}
				Frames++;
				}
			LastFrameTime = CurrentTime;
			}
				
				if (Vi<=temp4)
					Vi++;
				else
					break;

			CenterCamera(x+Vi*temp_x, y+Vi*temp_y, z+Vi*temp_z);
			if (rads != undefined)
			{
			RotateCamera(rads, false, false);
			}

				DrawMap();
				FlipScreen();
		}
	CenterCamera(x2, y2, z2);
	}
	else //queue this into the engine
	{
		if (rads != undefined)
		{
		RotateCamera(rads, true, false, 0,0,0,temp4);
		}
		for (Vi=0; Vi<= temp4; Vi++)
		{
		SetMapDelayScript(Vi, "action", "CenterCamera("+(x+Vi*temp_x)+","+(y+Vi*temp_y)+","+(z+Vi*temp_z)+");");

		} 
		SetMapDelayScript(Math.floor(temp4)+1, "action", "CenterCamera("+x2+","+y2+","+z2+");");
	}
}

function SpanAll(queue,totalframes,x1,y1,z1,x2,y2,z2, rotation, tilt, scale_change)
{
	if (rotation == undefined)
		rotation = 0;
	if (tilt == undefined)
		tilt = 0;
	if (scale_change == undefined)
		scale_change = 0;
	if (totalframes==undefined)
		totalframes = 25;
	
var xdiff = (x2-x1)/totalframes;
var ydiff = (y2-y1)/totalframes;
var zdiff = (z2-z1)/totalframes;

rotation/=totalframes;
tilt/= totalframes;
scale_change/=totalframes;

var CurrentTime = 0;
LastFrameTime = 0;
var startframes = Frames;

	if (queue == false || queue == undefined)
	{
		while (Frames<startframes+totalframes)
		{
			CurrentTime = GetTime();

			if (CurrentTime-LastFrameTime > FrameSec)
			{
				for (fci1=0; fci1<FrameSec; fci1+= (CurrentTime-LastFrameTime))
				{
					if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
					{
					AddFrameAll();
					}
				Frames++;
				x_angle+=rotation;
				y_angle+=rotation;
				TiltAmount+=tilt;
				SetScale(Scale+scale_change);
				RearrangeAngle();
				}
			LastFrameTime = CurrentTime;
			}

				CenterCamera(x1+xdiff*(Frames-startframes),y1+ydiff*(Frames-startframes),z1+zdiff*(Frames-startframes));
				DrawMap();
				FlipScreen();
		}
	CenterCamera(x2, y2, z2);
	}
	else //queue this into the engine
	{
		for (fci=0; fci<= totalframes; fci++)
		{
		SetMapDelayScript(fci, "action", "x_angle+="+rotation+"; y_angle+="+rotation+"; TiltAmount+="+tilt+"; SetScale(Scale+"+scale_change+"); CenterCamera("+(x1+xdiff*fci)+","+(y1+ydiff*fci)+","+(z1+zdiff*fci)+"); RearrangeAngle();");
		} 
		SetMapDelayScript(totalframes, "action", "CenterCamera("+x2+","+y2+","+z2+");");
	}
}


function WaitFrames(numframes)
{
//Advance the engine "numframes" frames
var startframes = Frames;
var CurrentTime = 0;
var StringChar = 0;
ExitMapEngine = false;

	
	while(startframes+numframes >= Frames)
	{
		CurrentTime = GetTime();

		if (CurrentTime-LastFrameTime > FrameSec)
		{
			for (fci5=0; fci5<FrameSec; fci5+= (CurrentTime-LastFrameTime))
			{
				if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
				{
				AddFrameAll();
				}

			Frames++;
			TheFrames++;
				if (ActionQueue[TheFrames] != undefined && ActionQueue[TheFrames] != "")
				{
					DoScript(ActionQueue[TheFrames]);
					ActionQueue[TheFrames] = undefined;
				}
				
				if (CurrentTime-LastFrameTime <= 0)
				{
						CurrentTime = GetTime();
						fci5 = FrameSec;
				}
			}
		LastFrameTime = CurrentTime;
		}

		//Draw this frame
			DrawMap();

			if (DrawQueue[TheFrames] != undefined && DrawQueue[TheFrames] != "")
			{
			DoScript(DrawQueue[TheFrames]);
			DrawQueue[TheFrames-1] = undefined;
			}
			if (Foreground == true)
			{
			DrawForeground();
			}
			
			FlipScreen();

			if (Foreground == true)
			{
				if (tempy2 == Math.floor(tempy2))
				{
					for (df1 = 0; df1 < LetterSkip; df1++)
					{
					TheString += Texts[CurrentText].charAt(tempy2*LetterSkip + df1);
					}
				}
				tempy2++;		
			}

		if (ExitMapEngine == true)
		{
		ExitMapEngine = false;
		return;
		}

		if (Advancing == true)
		{
		AdvancingFunc();
		}
	}
}

