/*
This is the main script file which loads all others.  It
also has the basic engine compountents and the map editor
*/

EvaluateSystemScript("input.js");
EvaluateSystemScript("time.js");

EvaluateScript("engine.js");
EvaluateScript("movement.js");
EvaluateScript("texts.js");
EvaluateScript("player.js");
EvaluateScript("cutscenes.js");
EvaluateScript("testing.js");
EvaluateScript("models.js");
EvaluateScript("battle.js");
EvaluateScript("fightindex.js");
EvaluateScript("ai.js");

var font = LoadFont("main.rfn");
var font2 = LoadFont("yfont.rfn");
var fontG = LoadFont("main.rfn");
fontG.setColorMask(CreateColor(128,128,128,255));


var window_style = LoadWindowStyle("main.rws");

var Vector = new Array();
var Square = new Array();
var Cube = new Array();
var Sprite = new Array();
var AnimatedTile = new Array();
var ATile = new Array();
var Zone = new Array();
var SpriteSet = new Array();
var Draw = new Array();
var TileSet = new Array();

var TileSet2 = new Array();//Tileset for overlaying tiles (eg red/blue selection tiles)

var NamedTileSet = new Array();
var ColourIndex = new Array();
var MaxCubes = 200;
var MaxZones = 10;

var MaxSprites = 20;
var MaxSpriteSets = 10;
var MaxFramesPerDiection = 20;
var MaxDiections = 20;

var MaxAnimations = 20;
var MaxAnimatedTiles = 50;

var zoneboo = false;
var shadeS = "t";

if (GetScreenWidth() == 320)
{
var ScaleBase = 1;
}
else
{
var ScaleBase = GetScreenWidth()/320;
}

var MapObject = new Object();


for (i=0; i<=MaxZones; i++)
{
Zone[i] = new Array();
	for (j=0; j<=MaxZones; j++)
	{
	Zone[i][j] = 0;
	}
}

for (i=0; i<MaxCubes; i++)
{
//Vector[i] = new Object();
//Square[i] = new Object();
Cube[i] = new Object();
Cube[i].sprite = -1;//no sprite
Cube[i].height = 0;
Cube[i].decal = false;
Cube[i].zone = 0;
Cube[i].model = -1;
Cube[i].type = -1;

Draw[i] = new Object();
Draw[i].d1 = 0;
Draw[i].d2 = 0;
Draw[i].d3 = 0;
Draw[i].d4 = 0;
Draw[i].d1r = 0;
Draw[i].d2r = 0;
Draw[i].d3r = 0;
Draw[i].d4r = 0;
}
for (i=0; i<MaxSprites; i++)
{
Sprite[i] = new Object();
Sprite[i].spriteset = 0;
Sprite[i].direction = 0;
Sprite[i].frame = 0;
Sprite[i].fdir = 1;
Draw[MaxCubes+i] = new Object();
Draw[MaxCubes+i].d1 = 0;
Draw[MaxCubes+i].d2 = 0;
Draw[MaxCubes+i].d3 = 0;
Draw[MaxCubes+i].d4 = 0;
}

function ResetSprites()
{
	for (rsi=0; rsi<MaxSprites; rsi++)
	{
	Sprite[rsi].cube = -1;
	Sprite[rsi].advancing = false;
	Sprite[rsi].index = -1;
	}
}

function ResetSpriteSets()
{
	for (rsi=0; rsi<MaxSpriteSets; rsi++)
	{
//		for (rsj=0; rsj<MaxDiections; rsj++)
//		{
//			for (rsk=0; rsk<MaxFramesPerDiection; rsk++)
//			{
			SpriteSet[rsi][0][0] = "";
//			}
//		}
	}
}


for (i=0; i<MaxAnimations; i++)
{
AnimatedTile[i] = new Array();
}
for (i=0; i<MaxAnimatedTiles; i++)
{
ATile[i] = new Object();
}



AnimatedTile[0][0] = 5;
AnimatedTile[0][1] = 1;
AnimatedTile[0][2] = 2;
AnimatedTile[0][3] = 3;
AnimatedTile[0][4] = 4;
AnimatedTile[0][5] = 5;

ATile[0].cube = -1;
ATile[0].anim = 0;//The animation being used
ATile[0].side = 1;
ATile[0].frame = 1;
ATile[1].cube = -1;
ATile[1].anim = 0;//The animation being used
ATile[1].side = 1;
ATile[1].frame = 3;

/*Format for animated tiles:

AnimatedTile[0][0] = number of frames in the animation.
AnimatedTile[0][1] = index of the first picture
AnimatedTile[0][2] = index of the second picture
AnimatedTile[0][..] = ..

ATile[0].cube = the cubes this animation runs on
ATile[0].anim = the animation to use
ATile[0].side = the side of the cubes this animation runs on
ATile[0].frame = the current frame of the animation
*/

/*
This next array is an array which stores if and what cube 
is at a particular x,y, and z.  Usually, I wouldn't consider
such a method as being very good, as it wastes a lot of 
memory on x,y,and z's that don't have a cube.  However, this will
be used hundreds of times per frame, so a method using code 
to check if there's a cube at a particular x,y, and z would 
take too long, and performace is the biggest worry in this 
program.
*/
var Pxyz = new Array();
for (i=-10; i<11; i++)
{
Pxyz[i] = new Array;
	for (j=-10; j<11; j++)
	{
	Pxyz[i][j] = new Array();
		for (k=-10; k<11; k++)
		{
		Pxyz[i][j][k] = -1;
		}
	}
}


Cube[0].sprite = 0;
Cube[62].sprite = 1;

for (i=0; i<MaxSpriteSets; i++)
{
SpriteSet[i] = new Array();
	for (j=0; j<MaxFramesPerDiection; j++)
	{
	SpriteSet[i][j] = new Array();
	}
}

SpriteSet[1][0][0] = "tree";			//Stem of the spriteset.
SpriteSet[1][0][1] = 0;						//xoff.
SpriteSet[1][0][2] = 0;						//yoff.

SpriteSet[1][1][0] = 1;						//Number of frames for this animation.
SpriteSet[1][1][1] = LoadImage("tree0.png");		

SpriteSet[1][2][0] = 1;						
SpriteSet[1][2][1] = LoadImage("tree0.png");
	
SpriteSet[1][3][0] = 1;						
SpriteSet[1][3][1] = LoadImage("tree0.png");		

SpriteSet[1][4][0] = 1;						
SpriteSet[1][4][1] = LoadImage("tree0.png");		

function LoadSpriteSetInfo(first, string)
{
var temp5 = CreateStringFromCode(47);
var slot = OpenFile(".." + temp5 + "spritesets" + temp5 + string +".ssf");

var temp6 = 1;
var lssi=0;

SpriteSet[first][0][0] = string;			//Stem of the spriteset.

	while(true)
	{
		if (slot.read(temp6+"L", -1) == -1)
			break;

		SpriteSet[first][temp6][0] = slot.read(temp6+"L",-1)+1;

		for (lssi=0; lssi<=slot.read(temp6+"L", -1); lssi++)
		{
			SpriteSet[first][temp6][lssi+1] = LoadImage(".." + temp5 + "spritesets" + temp5 + string + temp5+ string+ slot.read(temp6,"") + lssi +".png");
		}	

	temp6++;
	}
SpriteSet[first][0][1] = slot.read("xoff", 0);	//xoff.
SpriteSet[first][0][2] = slot.read("yoff", 0);	//yoff.
}

LoadSpriteSetInfo(2, "demon");
LoadSpriteSetInfo(3, "bull");
LoadSpriteSetInfo(4, "elmdor");
LoadSpriteSetInfo(1, "rock");

MapObject.Tileset = "Tile1.mts"; //.mts = Map TileSet
MapObject.ss1 = "Sprite1.mss"; //.mts = Map SpriteSet
MapObject.ss2 = "Sprite2.mss"; //.mts = Map SpriteSet

function LoadTheTileset(ts)
{
	var tileslot = OpenFile(ts);
	var the_temp = tileslot.read("NTS0", 1);

	NamedTileSet[0] = the_temp;
	TileSet[0] = the_temp;

	for (j1 = 1; j1<the_temp; j1++)
	{
	NamedTileSet[j1] = tileslot.read("NTS"+j1, "1.png");
	TileSet[j1] = LoadImage(tileslot.read("NTS"+j1, "1.png"));
	}
}

//Triangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, TileSet2[Cube[n].pA]);
//Triangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, TileSet2[Cube[n].pA]);

TileSet2[0] = CreateColor(0,0,255, 128);
TileSet2[1] = CreateColor(255,0,0, 128);
TileSet2[2] = LoadImage("Arrow1.png");
TileSet2[3] = CreateColor(0,0,255, 255);
TileSet2[4] = CreateColor(255,0,0, 255);
TileSet2[5] = CreateColor(255,255,0, 255);


//var SpriteNumber = 1;
/*Sprite[0].direction = 1;
Sprite[0].fdir = 1;
Sprite[0].frame = 1;
Sprite[0].spriteset = 1;
Sprite[0].xoff = LoadImage("Sprite1.png").width/2;
Sprite[0].yoff = LoadImage("Sprite1.png").height;
Sprite[0].xadd = 0;
Sprite[0].yadd = 0;
Sprite[0].cube = 0;
*/

Sprite[1].direction = 1; //The direction the sprite is physically facing on the screen.
Sprite[1].fdir = 1;//the direction the sprite is facing (with reference to direction "d1");
Sprite[1].frame = 6;
Sprite[1].spriteset = 3;
Sprite[1].xoff = SpriteSet[Sprite[1].spriteset][1][1].width/2;
Sprite[1].yoff = SpriteSet[Sprite[1].spriteset][1][1].height-20;
Sprite[1].yoff2 = 0;
Sprite[1].xadd = 0;
Sprite[1].yadd = 0;
Sprite[1].zadd = 0;
Sprite[1].cube = 62;

Sprite[0].direction = 1; //The direction the sprite is physically facing on the screen.
Sprite[0].fdir = 1;
Sprite[0].frame = 1;
Sprite[0].spriteset = 1;
Sprite[0].xoff = SpriteSet[Sprite[0].spriteset][1][1].width/2;
Sprite[0].yoff = SpriteSet[Sprite[0].spriteset][1][1].height-16;
Sprite[0].yoff2 = 0;
Sprite[0].xadd = 0;
Sprite[0].yadd = 0;
Sprite[0].zadd = 0;
Sprite[0].cube = 0;

Sprite[2].direction = 1; //The direction the sprite is physically facing on the screen.
Sprite[2].fdir = 1;//the direction the sprite is facing (with reference to direction "d1");
Sprite[2].frame = 3;
Sprite[2].spriteset = 4;
Sprite[2].xoff = SpriteSet[Sprite[2].spriteset][1][1].width/2;
Sprite[2].yoff = SpriteSet[Sprite[2].spriteset][1][1].height-20;
Sprite[2].yoff2 = 0;
Sprite[2].xadd = 0;
Sprite[2].yadd = 0;
Sprite[2].zadd = 0;
Sprite[2].cube = 62;

Sprite[1].index = 1;
Sprite[2].index = 2;


function SetSpriteSet(sprite,spriteset)
{
Sprite[sprite].spriteset = spriteset;
Sprite[sprite].xoff = SpriteSet[spriteset][0][1];
Sprite[sprite].yoff = SpriteSet[spriteset][0][2];
Sprite[sprite].xadd = 0;
Sprite[sprite].yadd = 0;
}

/*
Sprite[2].direction = 1;
Sprite[2].frame = 1;
Sprite[2].spriteset = 2;
Sprite[2].xoff = LoadImage("demon_walk1.png").width/2;
Sprite[2].yoff = LoadImage("demon_walk1.png").height;
*/

var units = 16; 
TileSet[0] = 4;//number of elements in this array
TileSet[1] = LoadImage("1.png");
TileSet[2] = LoadImage("2.png");
TileSet[3] = LoadImage("3.png");

NamedTileSet[0] = 4; //Number of elements in this tileset
NamedTileSet[1] = "1.png";
NamedTileSet[2] = "2.png";
NamedTileSet[3] = "3.png";

var CDir = "d1"; //This is the variable tells which stuff should be draw first on the screen 
var Backwards = false;
var font = LoadFont("main.rfn");
var window_style = LoadWindowStyle("main.rws");


//Colour index information

for (i=0; i<32; i++)
{
ColourIndex[i] = CreateColor(0,0,0,i*8);
}






/*
        d3
     
     5  / \  4
      /  1  \
     |\     /|
d4   |  \ /  |   d2
      \  |  /
        \|/
      2    3

         d1 

Turbie's Super Fun Happy Hour
numbers = cube face number
d+numbers = direction number (d2 is faces the cube from the east)
*/
Cube[0].x = -1;
Cube[0].y = 1;
Cube[0].z = 1;

Cube[0].t1 = 1;
Cube[0].t2 = 2;
Cube[0].t3 = 1;
Cube[0].t4 = 1;
Cube[0].pic1 = 1;
Cube[0].pic2 = 2;
Cube[0].pic3 = 3;
Cube[0].pic4 = 3;
Cube[0].pic5 = 3;



var CubeNumber = 34;
var temp = 0;

var Grid = true;
var TileSize = 40;
var GridColor = CreateColor(0,0,0,255);
var CubeColor = CreateColor(0,255,255,255);
var FaceColor = CreateColor(0,0,0,128);
var Scale = 1;
var CameraX = -150;
var CameraY = -150;
//var renderforward = false;
var SquareCount = 0;

var x_a_start = 3.14159/4;

var x_angle = 3.14159/4;
var y_angle = -3.14159/4;
var z_angle = 3.14159/2
var CurrentCube = 0;
var CurrentFace = 1;

var ModX_x = 1;
var ModX_y = 1;
var ModY_x = 1;
var ModY_y = 1;
var ModZ_y = -1*Scale*ScaleBase;

var z_angle = 0;
var TiltAmount = 1;
var ZFactor = 1;//.75;
var first = false;
var tempboo = false;
var LDCube = 0;//the last Cube that was drawn
var CDirR = false;//Tells which draw order to be used.
var FrameRate = 24;
var FrameUpdateRate = 5; 
var Editor = true;
/*
function ModX_x(n)
{
return n*CosX;
}
function ModX_y(n)
{
return n*SinX;
}
function ModY_x(n)
{
return n*CosY;
}
function ModY_y(n)
{
return n*SinY;
}

function ModZ_x(n)
{
return 0;
//return ZFactor*n*Math.cos(z_angle)*Scale;//=0;
}
function ModZ_y(n)
{
return n*ZFactorP;
//return ZFactor*n*Math.sin(z_angle)*Scale;//-1;

}
*/





/*
function DrawSquare(n)
{
LoadImage(Square[n].pic).transformBlit(ModX_x(Square[n].sx) + ModY_x(Square[n].sy) + ModZ_x(Square[n].sz) - CameraX, ModX_y(Square[n].sx) + ModY_y(Square[n].sy) + ModZ_y(Square[n].sz) - CameraY,ModX_x(Square[n].x2) + ModY_x(Square[n].y2) + ModZ_x(Square[n].z2) - CameraX, ModX_y(Square[n].x2) + ModY_y(Square[n].y2) + ModZ_y(Square[n].z2) - CameraY,ModX_x(Square[n].x3) + ModY_x(Square[n].y3) + ModZ_x(Square[n].z3) - CameraX,ModX_y(Square[n].x3) + ModY_y(Square[n].y3) + ModZ_y(Square[n].z3) - CameraY,ModX_x(Square[n].x4) + ModY_x(Square[n].y4) + ModZ_x(Square[n].z4) - CameraX,ModX_y(Square[n].x4) + ModY_y(Square[n].y4) + ModZ_y(Square[n].z4) - CameraY);

	if (Grid == true)
	{
	Line(ModX_x(Square[n].sx) + ModY_x(Square[n].sy) + ModZ_x(Square[n].sz) - CameraX, ModX_y(Square[n].sx) + ModY_y(Square[n].sy) + ModZ_y(Square[n].sz) - CameraY, ModX_x(Square[n].x2) + ModY_x(Square[n].y2) + ModZ_x(Square[n].z2) - CameraX, ModX_y(Square[n].x2) + ModY_y(Square[n].y2) + ModZ_y(Square[n].z2) - CameraY, GridColor);
	Line(ModX_x(Square[n].x2) + ModY_x(Square[n].y2) + ModZ_x(Square[n].z2) - CameraX, ModX_y(Square[n].x2) + ModY_y(Square[n].y2) + ModZ_y(Square[n].z2) - CameraY, ModX_x(Square[n].x3) + ModY_x(Square[n].y3) + ModZ_x(Square[n].z3) - CameraX, ModX_y(Square[n].x3) + ModY_y(Square[n].y3) + ModZ_y(Square[n].z3) - CameraY, GridColor);
	Line(ModX_x(Square[n].x3) + ModY_x(Square[n].y3) + ModZ_x(Square[n].z3) - CameraX, ModX_y(Square[n].x3) + ModY_y(Square[n].y3) + ModZ_y(Square[n].z3) - CameraY, ModX_x(Square[n].x4) + ModY_x(Square[n].y4) + ModZ_x(Square[n].z4) - CameraX, ModX_y(Square[n].x4) + ModY_y(Square[n].y4) + ModZ_y(Square[n].z4) - CameraY, GridColor);
	Line(ModX_x(Square[n].x4) + ModY_x(Square[n].y4) + ModZ_x(Square[n].z4) - CameraX, ModX_y(Square[n].x4) + ModY_y(Square[n].y4) + ModZ_y(Square[n].z4) - CameraY, ModX_x(Square[n].sx) + ModY_x(Square[n].sy) + ModZ_x(Square[n].sz) - CameraX, ModX_y(Square[n].sx) + ModY_y(Square[n].sy) + ModZ_y(Square[n].sz) - CameraY, GridColor);
	}
}

function DrawVector(n)
{
Line(ModX_sx(n) + ModY_sx(n),ModX_sy(n) + ModY_sy(n) - Vector[n].sz, ModX_sx(n) + ModY_sx(n) + ModX_x(n) + ModY_x(n), ModX_sy(n) + ModY_sy(n) - Vector[n].sz + ModX_y(n) + ModY_y(n) - Vector[n].z, CreateColor(255,255,255,255));
}
*/

function DrawSide(number, n) 
//'number' is side number, 'n' is cube number
{
var TheCube = Cube[n];
TempX = TheCube.x*TileSize; 
TempY = TheCube.y*TileSize; 
TempZ = TheCube.z*TileSize; 
tempboo = false;

	if (number == CurrentFace && n == CurrentCube)
	{
	tempboo = true;
	}

	if (number == 5)
	{
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic5,n);
	}
	else if (number == 4)
	{
	DrawSquareNormal(ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	TheCube.pic4,n);
	}
	else if (number == 3)
	{
	DrawSquareNormal(ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize)*/ /*+ ModZ_x(TheCube.t2*TileSize) */, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic3,n);
	}
	else if (number == 2)
	{
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic2,n);
	}
	else if (number == 1)
	{
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/,       ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize),
	TheCube.pic1,n);
	}
}


var side = 0;

function DrawCube(n)//, z)
{
//var TheCubey = Cube[n];
side = 0;
var TheCube = Cube[n];
TempX = TheCube.x*TileSize; 
TempY = TheCube.y*TileSize; 
TempZ = TheCube.z*TileSize; 
tempboo = false;

	if (n<CubeNumber+1)
	{
			if (TheCube.pic1 > 0)
			{
//			DrawSide(1, n);
				if (MoveArrow == n)
					DrawArrow();
				
				if (1 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}

	side = 1;
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/,       ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize),
	TheCube.pic1,n);

			}
			if (Cube[n].sprite >= 0)	//this has a sprite
			{
			DrawSprite(n);
			}

			if (Cube[n].model >= 0)
			{
			DrawModel(Cube[n].model,Cube[n].x, Cube[n].y, Cube[n].z+Cube[n].height);
			}

			if (MoveArrow == n)
			{
			DrawArrow();
			}

			if (zoneboo == true)
			{
			DrawZoneNum(n);
			}

		if (CDir == "d1")
		{

			if (TheCube.pic2 > 0)
			{
//			DrawSide(2, n);
				if (2 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}


	side = 2;
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic2,n);

			}

			if (TheCube.pic3 > 0)
			{
//			DrawSide(3, n);

				if (3 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}

	side = 3;
	DrawSquareNormal(ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize)*/ /*+ ModZ_x(TheCube.t2*TileSize) */, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic3,n);
			}
		}
		else if (CDir == "d2")
		{

			if (TheCube.pic3 > 0)
			{
//			DrawSide(3, n);
				if (3 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 3;
	DrawSquareNormal(ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize)*/ /*+ ModZ_x(TheCube.t2*TileSize) */, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic3,n);
			}

			if (TheCube.pic4 > 0)
			{
//			DrawSide(4, n);
				if (4 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 4;
	DrawSquareNormal(ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	TheCube.pic4,n);

			}
		}
		else if (CDir == "d3")
		{
			if (TheCube.pic5 > 0)
			{
//			DrawSide(5, n);
				if (5 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 5;
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic5,n);


			}

			if (TheCube.pic4 > 0)
			{
//			DrawSide(4, n);
				if (4 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 4;
	DrawSquareNormal(ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t3*TileSize) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t3*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	TheCube.pic4,n);
			}
		}

		else// if (CDir == "d4")
		{
			if (TheCube.pic5 > 0)
			{
//			DrawSide(5, n);
				if (5 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 5;
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ) + ModZ_x(TheCube.t2*TileSize)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*(TempZ + TheCube.t2*TileSize), 
	ModX_x*TempX + ModY_x*(TempY+TileSize)/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*(TempY+TileSize) + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic5,n);
			}

			if (TheCube.pic2 > 0)
			{
//			DrawSide(2, n);
				if (2 == CurrentFace && n == CurrentCube)
				{
				tempboo = true;
				}
	side = 2;
	DrawSquareNormal(ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t1*TileSize)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t1*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ) + ModZ_x(TheCube.t4*TileSize)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*(TempZ + TheCube.t4*TileSize), 
	ModX_x*(TempX+TileSize) + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*(TempX+TileSize) + ModY_y*TempY + ModZ_y*TempZ, 
	ModX_x*TempX + ModY_x*TempY/* + ModZ_x(TempZ)*/, ModX_y*TempX + ModY_y*TempY + ModZ_y*TempZ, 
	TheCube.pic2,n);
			}
		}
	}

/*	if (Cube[n].sprite >= 0)	//this has a sprite
	{
	DrawSprite(n);
	}
*/}

function DrawSprite(sprite)
{
	var TheSprite = Cube[sprite];

	var SpriteX = (TheSprite.x+.5 + Sprite[TheSprite.sprite].xadd)*TileSize;
	var SpriteY = (TheSprite.y+.5 + Sprite[TheSprite.sprite].yadd)*TileSize;
	var SpriteZ = (TheSprite.z+ Sprite[TheSprite.sprite].zadd + (TheSprite.t1+TheSprite.t2+TheSprite.t3+TheSprite.t4)/4)*TileSize + TileSize/2;
	
//	if (Sprite[TheSprite.sprite].zadd == undefined)

	SpriteSet[Sprite[TheSprite.sprite].spriteset][Sprite[TheSprite.sprite].direction][Sprite[TheSprite.sprite].frame].zoomBlit(
	ModX_x*SpriteX + ModY_x*SpriteY - CameraX - Sprite[TheSprite.sprite].xoff*Scale*ScaleBase*1.5/*+ Sprite[TheSprite.sprite].xadd*/,
	ModX_y*SpriteX + ModY_y*SpriteY + ModZ_y*SpriteZ - CameraY-Sprite[TheSprite.sprite].yoff*Scale*ScaleBase*1.5 /*+ Sprite[TheSprite.sprite].yadd*/+ Sprite[TheSprite.sprite].yoff2, 
	Scale*ScaleBase*1.5);
}

function DrawArrow()
{
	TileSet2[2].zoomBlit(
	ModX_x*(Cube[MoveArrow].x+.5)*TileSize + ModY_x*(Cube[MoveArrow].y+.5)*TileSize - CameraX - 16*Scale*ScaleBase*1.5,
	ModX_y*(Cube[MoveArrow].x+.5)*TileSize + ModY_y*(Cube[MoveArrow].y+.5)*TileSize + ModZ_y*(Cube[MoveArrow].z+Cube[MoveArrow].height)*TileSize -CameraY - 96*Scale*ScaleBase*1.5, 
	Scale*ScaleBase*1.5);
}
function DrawZoneNum(the_n)
{
	var TheCubey = Cube[the_n];
	
	if (TheCubey.pic1 > 0)
	{
	var X = (TheCubey.x+.5)*TileSize;
	var Y = (TheCubey.y+.5)*TileSize;
	var Z = (TheCubey.z + TheCubey.height)*TileSize;

	font.drawText(X*ModX_x + Y*ModY_x - CameraX-4, X*ModX_y + Y*ModY_y + Z*ModZ_y - CameraY-4, TheCubey.zone);
	}
}

function DrawSquareNormal(x1,y1,x2,y2,x3,y3,x4,y4, pic,n)
{
var Cx1 = x1-CameraX;
var Cx2 = x2-CameraX;
var Cx3 = x3-CameraX;
var Cx4 = x4-CameraX;

var Cy1 = y1-CameraY;
var Cy2 = y2-CameraY;
var Cy3 = y3-CameraY;
var Cy4 = y4-CameraY;
	//Check to see if this 'square' has to be drawn
	
	if (CheckSquare(Cx1,Cy1,Cx2,Cy2,Cx3,Cy3,Cx4,Cy4) == true)
	{
	SquareCount++;

		if (tempboo == true && Editor == true)
		{
		TileSet[pic].transformBlit(Cx1,Cy1,Cx2,Cy2,Cx3,Cy3,Cx4,Cy4);
		Triangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, FaceColor);
		Triangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, FaceColor);
		}
		else if (n == CurrentCube && Editor == true)
		{
		Triangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, CubeColor);
		Triangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, CubeColor);
		}
		else
		{
			if (Cube[n].pB >= 0&&side == 1)
			{
				Triangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, TileSet2[Cube[n].pB]);
				Triangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, TileSet2[Cube[n].pB]);
			}
			else if (Cube[n].pA >= 0&&side == 1)
			{
				Triangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, TileSet2[Cube[n].pA]);
				Triangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, TileSet2[Cube[n].pA]);
			}
			else
			{
				TileSet[pic].transformBlit(Cx1,Cy1,Cx2,Cy2,Cx3,Cy3,Cx4,Cy4);
			}

			if (side == 1)
			{
			GradientTriangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].t2c], ColourIndex[Cube[n].t3c])
			GradientTriangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].t3c], ColourIndex[Cube[n].t4c])
			}
			else if (side == 2)
			{
			GradientTriangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].b4c])
			GradientTriangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].b4c], ColourIndex[Cube[n].b1c])
			}
			else if (side == 3)
			{
			GradientTriangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, ColourIndex[Cube[n].t4c], ColourIndex[Cube[n].t3c], ColourIndex[Cube[n].b3c])
			GradientTriangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, ColourIndex[Cube[n].t4c], ColourIndex[Cube[n].b3c], ColourIndex[Cube[n].b4c])
			}
			else if (side == 4)
			{
			GradientTriangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, ColourIndex[Cube[n].t2c], ColourIndex[Cube[n].t3c], ColourIndex[Cube[n].b3c])
			GradientTriangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, ColourIndex[Cube[n].t2c], ColourIndex[Cube[n].b3c], ColourIndex[Cube[n].b2c])
			}
			else if (side == 5)
			{
			GradientTriangle(Cx1, Cy1, Cx2, Cy2, Cx3, Cy3, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].t2c], ColourIndex[Cube[n].b2c])
			GradientTriangle(Cx1, Cy1, Cx3, Cy3, Cx4, Cy4, ColourIndex[Cube[n].t1c], ColourIndex[Cube[n].b2c], ColourIndex[Cube[n].b1c])
			}
		}

		if (Grid == true && Cube[n].decal == false)
		{
		Line(Cx1, Cy1, Cx2, Cy2, GridColor);
		Line(Cx2, Cy2, Cx3, Cy3, GridColor);
		Line(Cx3, Cy3, Cx4, Cy4, GridColor);
		Line(Cx4, Cy4, Cx1, Cy1, GridColor);
		}
	}
tempboo = false;
}
function CheckSquare(X1,Y1,X2,Y2,X3,Y3,X4,Y4)
{
//This function checks to if one of the four points is one the
//expanded screen -TileSize*Scale<x<GetScreenWidth()+TileSize*Scale
//-TileSize*Scale<y<GetScreenHeigth()+TileSize*Scale

//If one of the points is on this screen, then the 'square' may have to be drawn.


var temp = -1*TileSize*Scale*ScaleBase;

var sheight = GetScreenHeight() - temp;
var swidth = GetScreenWidth() - temp;

	if ( (X1 >= temp && X1 <= swidth && Y1 >= temp && Y1 <= sheight)
	|| (X2 >= temp && X2 <= swidth && Y2 >= temp && Y2 <= sheight)
	|| (X3 >= temp && X3 <= swidth && Y3 >= temp && Y3 <= sheight)
	|| (X4 >= temp && X4 <= swidth && Y4 >= temp && Y4 <= sheight) ) 
	{
	return true;
	}
return false;
}

function game()
{
	if (first == false)
	{
	Menu();
	return;
	}
}

function MapEditor(standardview)
{
Editor = true;

var Sprite_temp = LoadImage('Sprite1.png');
var Cameratempx = 0;
var Cameratempy = 0;
var Cameratempz = 0;
first = true;
//SortDrawingCubes();
RearrangeAngle();
var Time = GetTime();
var movetoggle = false;
x_a_start = -3.141569/4;
y_angle = 3.141569/4;
x_angle = -3.141569/4;
Scale = .75;
//CameraY = -150;

	if (standardview == true || standardview == undefined)
	{
	CameraX = -150;
	CameraY = -94;
	}

Frames = 0;

	for (j=-100; j<100; j++)
	{
			for (i=0; i<CubeNumber; i++)
			{
			DrawCube(Draw[i].d1);
			}
	x_a_start += 3.141569/(400);
	y_angle-=3.141569/(400);
	x_angle+=3.141569/(400);
	RearrangeAngle();
	FlipScreen();
	}
	x_a_start = 3.141569/4;
	y_angle =-3.141569/4;
	x_angle = 3.141569/4;


	while(true)
	{	
	SquareCount = 0;
	Frames++;
/*		x_angle+= .05;
		y_angle+= .05;
		RearrangeAngle();
*/
		DrawMap();
		DrawCube(CurrentCube); //Draw the current cube last so the user can always see it
		font.drawText(0,220, "X Angle: " + x_angle);
		font.drawText(0,230, "Y Angle: " + y_angle);
		font.drawText(0,210, "Current cube: " + CurrentCube);
		font.drawText(0,190, "Shading top/bottom: " + shadeS);

		font.drawText(0,200, "Direction: " + CDir);
		font.drawText(0,180, "ZFact: " + ZFactor);

		font.drawText(200,190, "Cube Face: " + CurrentFace);
		font.drawText(200,200, "Cube Zone: " + Cube[CurrentCube].zone);
		font.drawText(200,220, "Cube X: " + Cube[CurrentCube].x);
		font.drawText(200,230, "Cube Y: " + Cube[CurrentCube].y);
		font.drawText(200,210, "Cube Z: " + Cube[CurrentCube].z);
		font.drawText(0,170, "Squares Drawn: " + SquareCount);
		FlipScreen();

		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_DOWN:
				{
				CameraY+= 8;
				break;
				}
				case KEY_UP:
				{
				CameraY-= 8;
				break;
				}
				case KEY_RIGHT:
				{
				CameraX+= 8;
				break;
				}
				case KEY_LEFT:
				{
				CameraX-= 8;
				break;
				}
				case KEY_G:
				{
					if (Grid==true)
					{
					Grid = false;
					}
					else
					{
					Grid = true;
					}
				break;
				}
				case KEY_A:
				{
				
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				
				ModX_x=ModX_x/(Scale*ScaleBase);
				ModX_y=ModX_y/(Scale*ScaleBase);
				ModY_x=ModY_x/(Scale*ScaleBase);
				ModY_y=ModY_y/(Scale*ScaleBase);
				Scale+= .05/ScaleBase;

				if (Scale <= 0)
				Scale = 0.01;

				ModX_x=ModX_x*Scale*ScaleBase;
				ModX_y=ModX_y*Scale*ScaleBase;
				ModY_x=ModY_x*Scale*ScaleBase;
				ModY_y=ModY_y*Scale*ScaleBase;
				ModZ_y=-1*ZFactor*Scale*ScaleBase;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
				break;
				}
				case KEY_Z:
				{
				Cameratempx = GetXPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempy = GetYPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);
				Cameratempz = GetZPointCenter(GetScreenWidth()/2, GetScreenHeight()/2);

				ModX_x=ModX_x/(Scale*ScaleBase);
				ModX_y=ModX_y/(Scale*ScaleBase);
				ModY_x=ModY_x/(Scale*ScaleBase);
				ModY_y=ModY_y/(Scale*ScaleBase);
				Scale-= .05/ScaleBase;
				
				if (Scale <= 0)
				Scale = 0.01;

				ModX_x=ModX_x*Scale*ScaleBase;
				ModX_y=ModX_y*Scale*ScaleBase;
				ModY_x=ModY_x*Scale*ScaleBase;
				ModY_y=ModY_y*Scale*ScaleBase;
				ModZ_y=-1*ZFactor*Scale*ScaleBase;
				CenterCamera(Cameratempx, Cameratempy, Cameratempz);
				break;
				}


				case KEY_Q:
				{
				x_angle+= .1;
				y_angle+= .1;

				/*
					if (x_angle <= 2*3.141569/3 && x_angle >= 3.141569/6)
					{
					y_angle = x_angle - (3.141569/3+(x_angle-3.141569/6)*3.141569/3);
					}
					else if (x_angle >= 2*3.141569/3 || x_angle <= -5*3.141569/6)
					{
					y_angle+=(.5/3);
					}
					else if (x_angle >= -5*3.141569/6 && x_angle <= -3.141569/3)
					{
					y_angle+=(.1/3);
					}
					else if (x_angle >= -3.141569/3 && x_angle <= 3.141569/6)
					{
					y_angle+=(.5/3);
					}
					
				
				y_angle += .1*(Math.sin(x_angle-3.141569/6)) + .1
				*/					
				RearrangeAngle();
				break;
				}
				case KEY_W:
				{
				x_angle-= .1;
				y_angle-= .1;
				RearrangeAngle();
				break;
				}
				case KEY_S:
				{
				ZFactor+=.05;
				ModZ_y = -1*ZFactor*Scale*ScaleBase;
				break;
				}
				case KEY_X:
				{
				ZFactor-=.05;
				ModZ_y = -1*ZFactor*Scale*ScaleBase;
				break;
				}
				case KEY_D:
				{
				TiltAmount+=0.025;
/*				x_a_start += 3.1141569/180
				y_angle-=3.141569/180;
				x_angle+=3.141569/180;
*/				RearrangeAngle();
				break;
				}
				case KEY_C:
				{
				TiltAmount-=0.025;
/*				x_a_start -= 3.1141569/180
				y_angle+=3.141569/180;
				x_angle-=3.141569/180;
*/				RearrangeAngle();
				break;
				}
/*				case KEY_F:
				{
				x_a_start+=.1;
				x_angle+=.1;
				RearrangeAngle();
				break;
				}
				case KEY_V:
				{
				x_a_start-=.1;
				x_angle-=.1;
				RearrangeAngle();
				break;
				}
*/
/*				case KEY_H:
				{
				y_angle+=.1;
				RearrangeAngle();
				break;
				}
				case KEY_N:
				{
				y_angle-=.1;
				RearrangeAngle();
				break;
				}
				case KEY_J:
				{
				x_angle+=.1;
				RearrangeAngle();
				break;
				}
				case KEY_M:
				{
				x_angle-=.1;
				RearrangeAngle();
				break;
				}
				case KEY_K:
				{
				z_angle+=.1;
				RearrangeAngle();
				break;
				}
				case KEY_L:
				{
				z_angle-=.1;
				RearrangeAngle();
				break;
				}
*/
				case KEY_F:
				{
					if ((Cube[CurrentCube].pic1!= undefined || Cube[CurrentCube].pic1 <0) && (Cube[CurrentCube].sprite < 0 || Cube[CurrentCube].sprite == undefined))
					{
					Cube[CurrentCube].sprite = 0;
					Sprite[0].cube = CurrentCube;
					Sprite[0].direction = 1;
					Sprite[0].frame = 1;
					Sprite[0].fdir = 1;
					}
					else if (Cube[CurrentCube].pic1!= undefined)
					{
						Cube[CurrentCube].sprite++;

						if (Cube[CurrentCube].sprite == 3)
						{
						Cube[CurrentCube].sprite = undefined;
						break;
						}
						Sprite[Cube[CurrentCube].sprite].direction = 1;
						Sprite[Cube[CurrentCube].sprite].frame = 1;
						Sprite[Cube[CurrentCube].sprite].fdir = 1;
						Sprite[Cube[CurrentCube].sprite].cube = CurrentCube;
					}
				break;
				}
				case KEY_V:
				{
					if (Cube[CurrentCube].sprite >=0)
					{
						if (Sprite[Cube[CurrentCube].sprite].cube != CurrentCube)
						{
						Sprite[Cube[CurrentCube].sprite].cube = undefined;
						}
					}
				break;
				}


				case KEY_TILDE:
				{
				CurrentCube++;
					if (CurrentCube > CubeNumber - 1)
					{
					CurrentCube = 0;
					}
				break;
				}
				case KEY_TAB:
				{
				CurrentCube--;
					if (CurrentCube < 0)
					{
					CurrentCube = CubeNumber - 1;
					}
				break;
				}
				case KEY_1:
				{
					if (CubeNumber < MaxCubes)
					{
					CubeNumber++;
					CurrentCube = CubeNumber - 1;
					Cube[CurrentCube].x = 0;
					Cube[CurrentCube].y = 0;
					Cube[CurrentCube].z = 0;
					Cube[CurrentCube].t1 = 1;
					Cube[CurrentCube].t2 = 1;
					Cube[CurrentCube].t3 = 1;
					Cube[CurrentCube].t4 = 1;
					Cube[CurrentCube].pic1 = 1;
					Cube[CurrentCube].pic2 = 1;
					Cube[CurrentCube].pic3 = 1;
					Cube[CurrentCube].pic4 = 1;
					Cube[CurrentCube].pic5 = 1;
					}
				break;
				}
				case KEY_2:
				{
					if (CubeNumber > 1)
					{
					CubeNumber--;
						for (i=CurrentCube; i<CubeNumber+1; i++)
						{
						Cube[i].x = Cube[i+1].x;
						Cube[i].y = Cube[i+1].y;
						Cube[i].z = Cube[i+1].z;
						Cube[i].t1 = Cube[i+1].t1;
						Cube[i].t2 = Cube[i+1].t2;
						Cube[i].t3 = Cube[i+1].t3;
						Cube[i].t4 = Cube[i+1].t4;
						Cube[i].pic1 = Cube[i+1].pic1;
						Cube[i].pic2 = Cube[i+1].pic2;
						Cube[i].pic3 = Cube[i+1].pic3;
						Cube[i].pic4 = Cube[i+1].pic4;
						Cube[i].pic5 = Cube[i+1].pic5;
						}
					}
				break;
				}
				case KEY_ENTER: //Quick Sorting of Cubes
				{
				SortDrawingCubes();
				break;
				}
				case KEY_BACKSLASH: //Full Sorting of Cubes
				{
				SortDrawingCubes(true);
				break;
				}
				case KEY_INSERT:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].x-=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].x-=1;
						}
					}
				break;
				}
				case KEY_DELETE:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].x+=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].x+=1;
						}
					}
				break;
				}
				case KEY_HOME:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].y+=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].y+=1;
						}
					}
				break;
				}
				case KEY_END:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].y-=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].y-=1;
						}
					}
				break;
				}
				case KEY_PAGEUP:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].z+=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].z+=1;
						}
					}
				break;
				}
				case KEY_PAGEDOWN:
				{
					if (movetoggle == false)
					{
					Cube[CurrentCube].z-=1;
					}
					else
					{
						for (i=0; i<CubeNumber; i++)
						{
						Cube[Draw[i].d1].z-=1;
						}
					}
				break;
				}
				case KEY_F1: //The help section :)
				{
				FlipScreen();
				font.drawTextBox(0,0, 320, 240, 5,"F1 - Help:\n down/left/right/up - movement\n A/Z - zoom in/out\n Q/W - rotate\n G - Toggle gridlines\n S/X - ZFactor +/-\n D/C - Tilt\n ~/Tab - scroll though cubes\n 1/2 - add/remove cube\n Enter - compute draw order\n Insert/Delete -  Cube x+/-\n Home/End - Cube y+/-\n Pgup/Pgdn - z+/-\n 9,0,-,= - increase vertix height\n o,p,[,], - decrease vertix height\n F5/F6 - face scroll\n F7/F8 - pic scroll\n Space - default view\n Backspace - Toggles MoveAll mode\N Escape - Menu");
				FlipScreen();
				GetKey();

				break;
				}
				case KEY_9:
				{
				Cube[CurrentCube].t1+=.5
				break;
				}
				case KEY_O:
				{
				Cube[CurrentCube].t1-=.5
				break;
				}
				case KEY_0:
				{
				Cube[CurrentCube].t2+=.5
				break;
				}
				case KEY_P:
				{
				Cube[CurrentCube].t2-=.5
				break;
				}
				case KEY_MINUS:
				{
				Cube[CurrentCube].t3+=.5
				break;
				}
				case KEY_OPENBRACE:
				{
				Cube[CurrentCube].t3-=.5
				break;
				}
				case KEY_EQUALS:
				{
				Cube[CurrentCube].t4+=.5
				break;
				}
				case KEY_CLOSEBRACE:
				{
				Cube[CurrentCube].t4-=.5
				break;
				}


				case KEY_5:
				{
				Cube[CurrentCube][shadeS+"1c"]+=2;
					if (Cube[CurrentCube][shadeS+"1c"] >= 32)
						Cube[CurrentCube][shadeS+"1c"]-=2;
				break;
				}
				case KEY_T:
				{
				Cube[CurrentCube][shadeS+"1c"]-=2;
					if (Cube[CurrentCube][shadeS+"1c"] <= -1)
						Cube[CurrentCube][shadeS+"1c"]+=2;
				break;
				}
				case KEY_6:
				{
				Cube[CurrentCube][shadeS+"2c"]+=2;
					if (Cube[CurrentCube][shadeS+"2c"] >= 32)
						Cube[CurrentCube][shadeS+"2c"]-=2;
				break;
				}
				case KEY_Y:
				{
				Cube[CurrentCube][shadeS+"2c"]-=2;
					if (Cube[CurrentCube][shadeS+"2c"] <= -1)
						Cube[CurrentCube][shadeS+"2c"]+=2;
				break;
				}
				case KEY_7:
				{
				Cube[CurrentCube][shadeS+"3c"]+=2;
					if (Cube[CurrentCube][shadeS+"3c"] >= 32)
						Cube[CurrentCube][shadeS+"3c"]-=2;
				break;
				}
				case KEY_U:
				{
				Cube[CurrentCube][shadeS+"3c"]-=2
					if (Cube[CurrentCube][shadeS+"3c"] <= -1)
						Cube[CurrentCube][shadeS+"3c"]+=2;
				break;
				}
				case KEY_8:
				{
				Cube[CurrentCube][shadeS+"4c"]+=2;
					if (Cube[CurrentCube][shadeS+"4c"] >= 32)
						Cube[CurrentCube][shadeS+"4c"]-=2;
				break;
				}
				case KEY_I:
				{
				Cube[CurrentCube][shadeS+"4c"]-=2;
					if (Cube[CurrentCube][shadeS+"4c"] <= -1)
						Cube[CurrentCube][shadeS+"4c"]+=2;
				break;
				}

				case KEY_4:
				{
					if (shadeS == "b")
						shadeS = "t";
					else
						shadeS = "b";
				break;
				}


				case KEY_F5:
				{
					if (CurrentFace > 1)
					{
					CurrentFace--;
					}
					else
					{
					CurrentFace = 5;
					}
				break;
				}
				case KEY_F6:
				{
					if (CurrentFace < 5)
					{
					CurrentFace++;
					}
					else
					{
					CurrentFace = 1;
					}
				break;
				}
				case KEY_F7:
				{
					if (CurrentFace == 1)
					{
						if (Cube[CurrentCube].pic1 < NamedTileSet[0] - 1)
						{
						Cube[CurrentCube].pic1++;
						}
						else
						{
						Cube[CurrentCube].pic1 = 0;
						}
					}
					else if (CurrentFace == 2)
					{
						if (Cube[CurrentCube].pic2 < NamedTileSet[0] -1)
						{
						Cube[CurrentCube].pic2++;
						}
						else
						{
						Cube[CurrentCube].pic2 = 0;
						}
					}
					else if (CurrentFace == 3)
					{
						if (Cube[CurrentCube].pic3 < NamedTileSet[0] -1)
						{
						Cube[CurrentCube].pic3++;
						}
						else
						{
						Cube[CurrentCube].pic3 = 0;
						}
					}
					else if (CurrentFace == 4)
					{
						if (Cube[CurrentCube].pic4 < NamedTileSet[0] -1)
						{
						Cube[CurrentCube].pic4++;
						}
						else
						{
						Cube[CurrentCube].pic4 = 0;
						}
					}
					else if (CurrentFace == 5)
					{
						if (Cube[CurrentCube].pic5 < NamedTileSet[0] -1)
						{
						Cube[CurrentCube].pic5++;
						}
						else
						{
						Cube[CurrentCube].pic5 = 0;
						}
					}
				break;
				}
				case KEY_F8:
				{
					if (CurrentFace == 1)
					{
						if (Cube[CurrentCube].pic1 > 0)
						{
						Cube[CurrentCube].pic1--;
						}
						else
						{
						Cube[CurrentCube].pic1 = NamedTileSet[0] - 1;
						}
					}
					else if (CurrentFace == 2)
					{
						if (Cube[CurrentCube].pic2 > 0)
						{
						Cube[CurrentCube].pic2--;
						}
						else
						{
						Cube[CurrentCube].pic2 = NamedTileSet[0] - 1;
						}
					}
					else if (CurrentFace == 3)
					{
						if (Cube[CurrentCube].pic3 > 0)
						{
						Cube[CurrentCube].pic3--;
						}
						else
						{
						Cube[CurrentCube].pic3 = NamedTileSet[0] - 1;
						}
					}
					else if (CurrentFace == 4)
					{
						if (Cube[CurrentCube].pic4 > 0)
						{
						Cube[CurrentCube].pic4--;
						}
						else
						{
						Cube[CurrentCube].pic4 = NamedTileSet[0] - 1;
						}
					}
					else if (CurrentFace == 5)
					{
						if (Cube[CurrentCube].pic5 > 0)
						{
						Cube[CurrentCube].pic5--;
						}
						else
						{
						Cube[CurrentCube].pic5 = NamedTileSet[0] - 1;
						}
					}

				break;
				}
				case KEY_F3:
				{
					if (Cube[CurrentCube].sprite == undefined)
					{
					Cube[CurrentCube].sprite = 0;
					}
					else if (Cube[CurrentCube].sprite == 1)
					{
					Cube[CurrentCube].sprite = undefined;
					}
					else
					{
					Cube[CurrentCube].sprite = 1;
					}

				break;
				}
				case KEY_PERIOD:
				{
					if (Cube[CurrentCube].sprite >= 0)
						MoveSprite(Cube[CurrentCube].sprite, "ne");
				break;
				}				
				case KEY_COMMA:
				{
					if (Cube[CurrentCube].sprite >= 0)
						MoveSprite(Cube[CurrentCube].sprite, "sw");
				break;
				}
				case KEY_SEMICOLON:
				{
					if (Cube[CurrentCube].sprite >= 0)
						MoveSprite(Cube[CurrentCube].sprite, "nw");
				break;
				}				
				case KEY_APOSTROPHE:
				{
					if (Cube[CurrentCube].sprite >= 0)
						MoveSprite(Cube[CurrentCube].sprite, "se");
				break;
				}
				case KEY_SLASH:
				{
					if (Cube[CurrentCube].decal == false)
					{
					Cube[CurrentCube].decal = true;
					}
					else
					{
					Cube[CurrentCube].decal = false;
					}
				break;
				}

				case KEY_B:
				{
					if (Model[Cube[CurrentCube].model+1][0].p1 > 0) 
						Cube[CurrentCube].model++;
					else
						Cube[CurrentCube].model = -1;
				break;
				}
				case KEY_N:
				{
					if (Sprite[Cube[CurrentCube].sprite+1].spriteset > 0) 
						Cube[CurrentCube].sprite++;
					else
						Cube[CurrentCube].sprite=-1;
				break;
				}
				case KEY_E:
				{
				Cube[CurrentCube].zone++;
					if (Cube[CurrentCube].zone > MaxZones)
					{
					Cube[CurrentCube].zone = 0;
					}
				break;
				}
				case KEY_R:
				{
					if (zoneboo == true)
						zoneboo = false;
					else
						zoneboo = true;
				break;
				}
				case KEY_SPACE://Sets the camera to the default position
				{
				x_a_start = 3.14159/4;
				x_angle = 3.14159/4;
				y_angle = -3.14159/4;
				CDir = "d1";
				CameraX=-150;
				CameraY= -94;
				Scale = .75;
				RearrangeAngle();
/*
				LoadFont("main.rfn").drawText(0,0,  x_angle);
				LoadFont("main.rfn").drawText(0,32,  y_angle);
				FlipScreen();
				GetKey();
*/
				break;
				}
				case KEY_BACKSPACE: //Toggles all move
				{
					if (movetoggle == false)
					{
					movetoggle = true;
					}
					else
					{
					movetoggle = false;
					}
				break;
				}
				case KEY_ESCAPE:
				{
				Menu();
				return;
				}
			}
		}
	}
}

/* Rotational
	with tilts not equal to 45 degrees every 90 degrees should make |x-y| into it's compliment.
	
	eg: x-y = 60, after 90 degrees: x-y = 120
*/



function TileSetEdit()
{
var selection = 0;
var top_selection = 0;
var Filelist = GetFileList('images');
var FilelistImage = new Array();
	for (i=0; i<3; i++)
	{
	FilelistImage[i] = LoadImage(Filelist[i]);
	}

var tempy = 0;
	while(true)
	{
		for (i=top_selection + 1; i<top_selection + 11; i++)
		{
			if (i < NamedTileSet[0])
			{
			font.drawText(20, 20*i, "Tile " + i + ": " + NamedTileSet[i]);
			}
		}
		//Draw current selection pic stuff;
		TileSet[selection+1].transformBlit(200, 20, 300,20, 300,120, 200,120);
		//Draw current directory image selected;
		FilelistImage[tempy].transformBlit(200, 130, 300,130, 300,230, 200,230);
		font.drawText(200, 230, FilelistImage[tempy]) 
		
		//Draw the arrow
		font.drawText(12, 20*(selection - top_selection + 1), "-") 
		FlipScreen();
		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_DOWN:
				{
					if (selection < TileSet[0] - 2)
					{
					selection++;
						if (selection - top_selection > 10)
						{
						top_selection++;
						}
					}
				break;
				}

				case KEY_UP:
				{
					if (selection > 0)
					{
					selection--;
						if (selection < top_selection)
						{
						top_selection--;
						}
					}
				break;
				}

				case KEY_PAGEDOWN:
				{
				tempy++;
				//Change current TileSet picture
				break;
				}
				case KEY_PAGEUP:
				{
					if (tempy > 0)
					{
					tempy--;
					}
				//Change current TileSet picture
				break;
				}
				case KEY_ENTER:
				{
				NamedTileSet[selection] = Filelist[tempy];
				TileSet[selection] = LoadImage(NamedTileSet[selection]);
				//Delete a picture from the tileset
				break;
				}
				case KEY_1:
				{
				NamedTileSet[0]++;
				TileSet[0]++;
				NamedTileSet[NamedTileSet[0]-1] = NamedTileSet[1];
				TileSet[NamedTileSet[0]-1] = TileSet[1];

				//Add a picture to the tileset
				break;
				}
				case KEY_2:
				{
				//Delete a picture from the tileset
				break;
				}

				case KEY_ESCAPE:
				{
				return;
				}
			}
		}
	}
}

function SortDrawingCubes()
{
var tempy = 0;
var tempy2 = 0;

	for (i=0; i<CubeNumber; i++)
	{
	Cube[i].height = (Cube[i].t1+Cube[i].t2+Cube[i].t3+Cube[i].t4)/4;
	}

		// sort the order of drawing cubes when the camera angle is d1
		for (k=10;k > -11; k--)//y
		{
			for (l=-10; l< 11; l++)//x
			{
				for (j=-10;j< 11; j++)//z
				{
					for (i=0; i<CubeNumber; i++)//number of cubes
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic3 != undefined) )
							{
							Pxyz[l][k][j] = i;
							Draw[tempy].d1 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == -k && Cube[i].y == -l && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic3 != undefined) )
							{
							Draw[tempy2].d1r = i;
							tempy2++;
							}
						} 
					}
					for (i=0; i<CubeNumber; i++)
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic3 != undefined) )
							{
							Draw[tempy].d1 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == -k && Cube[i].y == -l && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic3 != undefined) )
							{
							Draw[tempy2].d1r = i;
							tempy2++;
							}
						} 
					}
				}
			}
		}

		font.drawText(0,0, "d1 done");
		FlipScreen();
		tempy = 0;
		tempy2 = 0;
		// sort the order of drawing cubes when the camera angle is d2
		for (l=-10; l< 11; l++)//x
		{
			for (k=-10;k< 11; k++)//y
			{
				for (j=-10;j< 11; j++)//z
				{
					for (i=0; i<CubeNumber;i++)//number of cubes
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal == false && ((Cube[i].pic1 != undefined || Cube[i].pic3 != undefined || Cube[i].pic4 != undefined)) )
							{
							Draw[tempy].d2 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == k && Cube[i].y == l && Cube[i].z == j)
						{
							if (Cube[i].decal == false && ((Cube[i].pic1 != undefined || Cube[i].pic3 != undefined || Cube[i].pic4 != undefined)) )
							{
							Draw[tempy2].d2r = i;
							tempy2++;
							}
						} 
					}
					for (i=0; i<CubeNumber;i++)
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal != false && ((Cube[i].pic1 != undefined || Cube[i].pic3 != undefined || Cube[i].pic4 != undefined)) )
							{
							Draw[tempy].d2 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == k && Cube[i].y == l && Cube[i].z == j)
						{
							if (Cube[i].decal != false && ((Cube[i].pic1 != undefined || Cube[i].pic3 != undefined || Cube[i].pic4 != undefined)) )
							{
							Draw[tempy2].d2r = i;
							tempy2++;
							}
						}
					}
				}
			}
		}

		font.drawText(0,0, "d2 done");
		FlipScreen();
		tempy = 0;
		tempy2 = 0;
		// sort the order of drawing cubes when the camera angle is d3

		for (k=-10;k< 11; k++)//y
		{
			for (l=10; l> -11; l--)//x
			{
				for (j=-10;j< 11; j++)//z
				{
					for (i=0; i<CubeNumber;i++)//number of cubes
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic4 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy].d3 = i;
							tempy++;
							}
						}
						if (Cube[i].x == -k && Cube[i].y == -l && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic4 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy2].d3r = i;
							tempy2++;
							}
						}
					}
					for (i=0; i<CubeNumber;i++)
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic4 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy].d3 = i;
							tempy++;
							}
						}

						if (Cube[i].x == -k && Cube[i].y == -l && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic4 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy2].d3r = i;
							tempy2++;
							}
						}
					}
				}
			}
		}

		font.drawText(0,0, "d3 done");
		FlipScreen();
		tempy = 0;
		tempy2 = 0;
		// sort the order of drawing cubes when the camera angle is d4

		for (l=10; l> -11; l--)//x
		{
			for (k=10;k> -11; k--)//y
			{
				for (j=-10; j< 11; j++)//z
				{
					for (i=0; i<CubeNumber;i++)//number of cubes
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy].d4 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == k && Cube[i].y == l && Cube[i].z == j)
						{
							if (Cube[i].decal == false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy2].d4r = i;
							tempy2++;
							}
						} 
					}
					for (i=0; i<CubeNumber;i++)
					{
						if (Cube[i].x == l && Cube[i].y == k && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy].d4 = i;
							tempy++;
							}
						} 
						if (Cube[i].x == k && Cube[i].y == l && Cube[i].z == j)
						{
							if (Cube[i].decal != false && (Cube[i].pic1 != undefined || Cube[i].pic2 != undefined || Cube[i].pic5 != undefined))
							{
							Draw[tempy2].d4r = i;
							tempy2++;
							}
						} 
					}
				}
			}
		}

	font.drawText(0,0, "d4 done");
	FlipScreen();

//	FlipScreen();
/*	for (i=0; i<20; i++)
	{
	font.drawText(0, i*20,Draw[i].d1 + " " + Draw[i].d2);
	}*/
	font.drawText(0,0, "Map Loaded!");	
	FlipScreen();
	GetKey();

}

function RearrangeAngle()
{
	// Rewrite the angles x,y,z, so they are between -pi and +pi
	if (x_angle < -1*3.14159)
	{
	x_angle += 2*3.14159;
	}

	if (x_angle > 1*3.14159)
	{
	x_angle -= 2*3.14159;//4159;
	}

	if (y_angle < -1*3.14159)
	{
	y_angle += 2*3.14159;
	}

	if (y_angle > 1*3.14159)
	{
	y_angle -= 2*3.14159;//4159;
	}

	if (z_angle < -1*3.14159)
	{
	z_angle += 2*3.14159;
	}

	if (z_angle > 1*3.14159)
	{
	z_angle -= 2*3.14159;//4159;
	}


	//Set the camera direction variable
	/*
	*/
/*
	if (x_angle > 3.141569/2 -4*(x_a_start) && x_angle +3.141569/2< 3.14159/2)
	{
	CDir = "d1";
	}
	else if (x_angle >= 3.14159/2 && x_angle <= 3.141569/2 + 2*(x_a_start))
	{
	CDir = "d2";
	}
	else if (x_angle > -3.14159/2 && x_angle < 3.141569/2 -4*(x_a_start))
	{
	CDir = "d4";
	}
	else //if (x_angle >= 5*3.14159/6 || x_angle <= -3.14159/2)
	{
	CDir = "d3";
	}
*/
/*
What if there's a check of the ModY_Y of 1? if it's negative and modY_x of 1 
is negative, then switch the camera angle.  Like how the human case
understands when to change the camera direction.
*/
	if (TiltAmount < 0)
		TiltAmount = 0;
	else if (TiltAmount > 1)
		TiltAmount = 1;
		
	ModX_x = Math.cos(x_angle)*Scale*ScaleBase;
	ModX_y = Math.sin(x_angle)*Scale*ScaleBase*TiltAmount;
	ModY_x = Math.cos(y_angle)*Scale*ScaleBase;
	ModY_y = Math.sin(y_angle)*Scale*ScaleBase*TiltAmount;
	ModZ_y = -1*Scale*ZFactor*ScaleBase;



	if (x_angle <= 3.14159/2 && /*ModY_y(1) <= 0 &&*/ ModY_x >=0)
	{
		if (CDir != "d1")
		{
		CDir = "d1";
		FixAllSpriteAngles();
		}
	CDir = "d1";
	}
	else if (x_angle >= 3.14159/2 /*&& ModY_y(-1) <= 0*/ && -1*ModY_x <=0)
	{
		if (CDir != "d2")
		{
		CDir = "d2";
		FixAllSpriteAngles();
		}
	CDir = "d2";
	}
	else if ((x_angle >= 3.14159/2 || x_angle <= -3.14159/2) && (ModY_x <=0 || ModY_y <=0))
	{
		if (CDir != "d3")
		{
		CDir = "d3";
		FixAllSpriteAngles();
		}
	CDir = "d3";
	}
	else
	{
		if (CDir != "d4")
		{
		CDir = "d4";
		FixAllSpriteAngles();
		}
	CDir = "d4";
	}
}

function FixAllSpriteAngles()
{
	for (i1=0; i1<MaxSprites; i1++)
	{
		if (Sprite[i1].cube >=0)
		{
		FixSpriteAngle(i1);
		}
	}
}

function FixSpriteAngle(sprite)
{
//4   3
//  
//1   2

/*
        d3
    
     5  / \  4
      /  1  \
     |\     /|
 d4  |  \ /  |   d2
      \  |  /
        \|/
      2    3

        d1 
            / \
          /     \
         |\     /|
         |  \ /  |
        / \  |  / \
      /     \|/     \
     |\     /|\     /|
     |  \ /  |  \ /  |
    / \  |  / \  |  / \
  /     \|/     \|/     \
 |\     /|\     /|\     /|
 |  \ /  |  \ /  |  \ /  |
  \  |  / \  |  / \  |  /
    \|/     \|/     \|/

Sprite[1].fdir = 1;//the direction the sprite is facing;
*/
	if (Sprite[sprite].direction <=4)
	{
		if (CDir == "d1")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir;
		}
		else if (CDir == "d2")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir - 1;
		}
		else if (CDir == "d3")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir - 2;
		}
		else//"d4"
		{
		Sprite[sprite].direction = Sprite[sprite].fdir - 3;//-1;
		}

		if (Sprite[sprite].direction < 1)
		{
		Sprite[sprite].direction+= 4;
		}
	}
	else if (Sprite[sprite].direction <=8)
	{
		if (CDir == "d1")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir+4;
		}
		else if (CDir == "d2")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir + 3;
		}
		else if (CDir == "d3")
		{
		Sprite[sprite].direction = Sprite[sprite].fdir + 2;
		}
		else//"d4"
		{
		Sprite[sprite].direction = Sprite[sprite].fdir + 1;//-1;
		}

		if (Sprite[sprite].direction < 5)
		{
		Sprite[sprite].direction+= 4;
		}
	}
}

function Menu()
{
//Save Map
//Load Map
//Quit;
var selection = 0;
//var top_selection = 0;
Editor = false;

FlipScreen();
  while (true) 
  {
		window_style.drawWindow(10, 10, 200, 100);

		// Menu items

		font.drawText(20,20, "New Map");
		font.drawText(20,40, "Save Map");
		font.drawText(20,60, "Load Map");
		font.drawText(20,80, "Engine");
		font.drawText(20,100, "Cutscenes");
		font.drawText(20,120, "Exit");

		// Selection arrow
		font.drawText(10, (selection + 1) * 20, "-");

		FlipScreen();

		while (AreKeysLeft()) 
		{
			switch (GetKey()) 
			{
				case KEY_ENTER: 
				{
					if (selection == 0)
					{
					NewMap();
					}
					else if (selection == 1)
					{
					SaveMap();
					}
					else if (selection == 2)
					{
					LoadMap();
					}
					else if (selection == 3)
					{
					NextFrame();
					}
					else if (selection == 4)
					{
					CutSceneMenu();
					}
				return;
				}

				case KEY_ESCAPE: 
				{
					if (first == true)
					{
					MapEditor();
					}
				return;
				}

				case KEY_DOWN: 
				{
					if (selection < 5)
					{
					selection++;
					}
				break;
				}

				case KEY_UP: 
				{
					if (selection > 0) 
					{
					selection--;
					}
				break;
				}
			}
		}
  }
}

function NewMap()
{
//Prompt for tileset
font.drawText(8,8,"Enter Tileset Name (no extensions):");
MapObject.Tileset = GetString(8, 20, font)

var temp5 = CreateStringFromCode(47);

LoadTheTileset(".." + temp5 + "Tilesets" + temp5 + MapObject.Tileset + ".mts");

MapObject.Tileset += ".mts";

Cube[0].x = 0;
Cube[0].y = 0;
Cube[0].z = 0;

Cube[0].t1 = 1;
Cube[0].t2 = 1;
Cube[0].t3 = 1;
Cube[0].t4 = 1;
Cube[0].pic1 = 1;
Cube[0].pic2 = 1;
Cube[0].pic3 = 1;
Cube[0].pic4 = 1;
Cube[0].pic5 = 1;
CubeNumber = 1;
	for (i=1; i<MaxCubes; i++)
	{
	Cube[i].x = undefined;
	Cube[i].y = undefined;
	Cube[i].z = undefined;

	Cube[i].t1 = undefined;
	Cube[i].t2 = undefined;
	Cube[i].t3 = undefined;
	Cube[i].t4 = undefined;
	Cube[i].pic1 = undefined;
	Cube[i].pic2 = undefined;
	Cube[i].pic3 = undefined;
	Cube[i].pic4 = undefined;
	Cube[i].pic5 = undefined;
	Cube[i].decal = false;
	Cube[i].zone = 0;
	}
GetPxyz();
CenterCamera(0,0,1);
MapEditor(false);
}

function SaveMap()
{
var MapName = "";

font.drawText(8,8,"Enter map Name (no extensions):");
MapName = GetString(8, 20, font)

var temp5 = CreateStringFromCode(47);
var Slot = OpenFile(".." + temp5 + "maps" + temp5 + MapName + ".slm")

	Slot.write("CNum", CubeNumber);
	Slot.write("ts", MapObject.Tileset);
//	Slot.write("ss1", MapObject.ss1);
//	Slot.write("ss2", MapObject.ss2);
	
	for (i=0; i<CubeNumber; i++)
	{
	Slot.write("C" + i + "x", Cube[i].x);
	Slot.write("C" + i + "y", Cube[i].y);
	Slot.write("C" + i + "z", Cube[i].z);

	Slot.write("C" + i + "t1", Cube[i].t1);
	Slot.write("C" + i + "t2", Cube[i].t2);
	Slot.write("C" + i + "t3", Cube[i].t3);
	Slot.write("C" + i + "t4", Cube[i].t4);

	Slot.write("C" + i + "t1c", Cube[i].t1c);
	Slot.write("C" + i + "t2c", Cube[i].t2c);
	Slot.write("C" + i + "t3c", Cube[i].t3c);
	Slot.write("C" + i + "t4c", Cube[i].t4c);

	Slot.write("C" + i + "b1c", Cube[i].b1c);
	Slot.write("C" + i + "b2c", Cube[i].b2c);
	Slot.write("C" + i + "b3c", Cube[i].b3c);
	Slot.write("C" + i + "b4c", Cube[i].b4c);


	Slot.write("C" + i + "p1", Cube[i].pic1);
	Slot.write("C" + i + "p2", Cube[i].pic2);
	Slot.write("C" + i + "p3", Cube[i].pic3);
	Slot.write("C" + i + "p4", Cube[i].pic4);
	Slot.write("C" + i + "p5", Cube[i].pic5);
	Slot.write("C" + i + "dc", Cube[i].decal);
	Slot.write("C" + i + "zone", Cube[i].zone);
	Slot.write("C" + i + "model", Cube[i].model);
	Slot.write("C" + i + "type", Cube[i].type);
	Slot.write("D" + i + "d1", Draw[i].d1);
	Slot.write("D" + i + "d2", Draw[i].d2);
	Slot.write("D" + i + "d3", Draw[i].d3);
	Slot.write("D" + i + "d4", Draw[i].d4);
	Slot.write("D" + i + "d1r", Draw[i].d1r);
	Slot.write("D" + i + "d2r", Draw[i].d2r);
	Slot.write("D" + i + "d3r", Draw[i].d3r);
	Slot.write("D" + i + "d4r", Draw[i].d4r);
	
		if (Cube[i].sprite >=0)
		{
		Slot.write("C" + i + "sprite", Cube[i].sprite);
		Slot.write("sprite" + Cube[i].sprite + "spriteset" , Sprite[Cube[i].sprite].spriteset);
		Slot.write("sprite" + Cube[i].sprite + "direction" , Sprite[Cube[i].sprite].direction);
		Slot.write("sprite" + Cube[i].sprite + "frame" , Sprite[Cube[i].sprite].frame);
		Slot.write("sprite" + Cube[i].sprite + "fdir" , Sprite[Cube[i].sprite].fdir);
		}
		if (i<MaxSpriteSets)
		{
			if (SpriteSet[i][1][0] >0)
			{
			Slot.write("SpriteSet" + i, SpriteSet[i][0][0]);
			}
		}
	}

	Slot.write("ZFac", ZFactor);

	Slot.flush();

MapEditor();
}

function LoadMap(name)
{
first = true;
var MapName = "";
Frames = 0;

	if (name == undefined)
	{
	font.drawText(8,8,"Enter map Name (no extensions):");
	MapName = GetString(8, 20, font)
	
	FlipScreen();
	font.drawText(0,0, "Map Loading, please wait...");
	FlipScreen();
	}
	else
	{
	MapName = name;
	}

MapObject.name = MapName;
//Clear old Data
CubeNumber = 0;
	for (i=0; i<MaxCubes; i++)
	{
	Cube[i].x = 0;
	Cube[i].y = 0;
	Cube[i].z = 0;

	Cube[i].t1 = 1.5;
	Cube[i].t2 = 1.5;
	Cube[i].t3 = 1.5;
	Cube[i].t4 = 1.5;
	Cube[i].t1c = 0;
	Cube[i].t2c = 0;
	Cube[i].t3c = 0;
	Cube[i].t4c = 0;
	Cube[i].b1c = 0;
	Cube[i].b2c = 0;
	Cube[i].b3c = 0;
	Cube[i].b4c = 0;
	Cube[i].pic1 = undefined;
	Cube[i].pic2 = undefined;
	Cube[i].pic3 = undefined;
	Cube[i].pic4 = undefined;
	Cube[i].pic5 = undefined;
	Cube[i].type = -1;
	Cube[i].sprite = -1;
	Cube[i].decal = false;
	Cube[i].zone = 0;
	Cube[i].model = -1;
	}
	var temp = TileSet[0];
	for (i=0; i<MaxAnimations; i++)
	{
		for (j=0; j<20; j++)
		{
			AnimatedTile[i][j] = -1;
		}
	}
	for (i=0; i<MaxAnimatedTiles; i++)
	{
		ATile[i].cube = -1;
		ATile[i].side = -1;
		ATile[i].frame = -1;
		ATile[i].anim = -1;
	}

	for (i=0; i<temp; i++)
	{
	NamedTileSet[i] = 0;
	}
	ZFactor = 0;

var temp5 = CreateStringFromCode(47);
var Slot = OpenFile(".." + temp5 + "maps" + temp5 + MapName + ".slm")
var Slot2 = Slot; 
	CubeNumber = Slot.read("CNum", 10);

	LoadAnimationInfo(MapName);

	MapObject.Tileset = Slot.read("ts", "Tileset1.mts");
//	MapObject.ss1 = Slot.read("ss1", "Sprite.mss");
//	MapObject.ss2 = Slot.read("ss2", "Sprite.mss");

	for (i=0; i<MaxSpriteSets; i++)
	{
		if (Slot.read("SpriteSet" + i, "null") != "null")
		{
		LoadSpriteSetInfo(i, Slot.read("SpriteSet" + i, "null"));
		}
	}

	for (i=0; i<CubeNumber; i++)
	{
	Cube[i].x = Slot.read("C" + i + "x", 0);
	Cube[i].y = Slot.read("C" + i + "y", 0);
	Cube[i].z = Slot.read("C" + i + "z", 0);

	Cube[i].t1 = Slot.read("C" + i + "t1", 1.5);
	Cube[i].t2 = Slot.read("C" + i + "t2", 1.5);
	Cube[i].t3 = Slot.read("C" + i + "t3", 1.5);
	Cube[i].t4 = Slot.read("C" + i + "t4", 1.5);

	Cube[i].t1c = Slot.read("C" + i + "t1c", 0);
	Cube[i].t2c = Slot.read("C" + i + "t2c", 0);
	Cube[i].t3c = Slot.read("C" + i + "t3c", 0);
	Cube[i].t4c = Slot.read("C" + i + "t4c", 0);
	Cube[i].b1c = Slot.read("C" + i + "b1c", 0);
	Cube[i].b2c = Slot.read("C" + i + "b2c", 0);
	Cube[i].b3c = Slot.read("C" + i + "b3c", 0);
	Cube[i].b4c = Slot.read("C" + i + "b4c", 0);

	Cube[i].pic1 = Slot.read("C" + i + "p1", 1);
	Cube[i].pic2 = Slot.read("C" + i + "p2", 1);
	Cube[i].pic3 = Slot.read("C" + i + "p3", 1);
	Cube[i].pic4 = Slot.read("C" + i + "p4", 1);
	Cube[i].pic5 = Slot.read("C" + i + "p5", 1);
	Cube[i].decal = Slot.read("C" + i + "dc", false);
	Cube[i].zone = Slot.read("C" + i + "zone", 0);
	Cube[i].model = Slot.read("C" + i + "model", -1);
	Cube[i].type = Slot.read("C" + i + "type", -1);
	Draw[i].d1 = Slot.read("D" + i + "d1", 1.0);
	Draw[i].d2 = Slot.read("D" + i + "d2", 1.0);
	Draw[i].d3 = Slot.read("D" + i + "d3", 1.0);
	Draw[i].d4 = Slot.read("D" + i + "d4", 1.0);

	Draw[i].d1r = Slot.read("D" + i + "d1r", 1.0);
	Draw[i].d2r = Slot.read("D" + i + "d2r", 1.0);
	Draw[i].d3r = Slot.read("D" + i + "d3r", 1.0);
	Draw[i].d4r = Slot.read("D" + i + "d4r", 1.0);
	Cube[i].height = (Cube[i].t1+Cube[i].t2+Cube[i].t3+Cube[i].t4)/4;

		if (Slot.read("C" + i + "sprite", -1) >=0)
		{
		Cube[i].sprite = Slot.read("C" + i + "sprite", -1);
		Sprite[Cube[i].sprite].cube = i;

		Sprite[Cube[i].sprite].spriteset = Slot.read("sprite" + Cube[i].sprite + "spriteset" , 0);

		Slot2 = OpenFile(".." + temp5 + "spritesets" + temp5 + SpriteSet[Sprite[Cube[i].sprite].spriteset][0][0] + ".ssf")
		
		Sprite[Cube[i].sprite].xoff = Slot2.read("xoff" , 0);
		Sprite[Cube[i].sprite].yoff = Slot2.read("yoff" , 0);
		Sprite[Cube[i].sprite].yoff2 = Slot2.read("yoff2" , 0);

		Sprite[Cube[i].sprite].direction = Slot.read("sprite" + Cube[i].sprite + "direction" , 0);
		Sprite[Cube[i].sprite].frame = Slot.read("sprite" + Cube[i].sprite + "frame" , 0);
		Sprite[Cube[i].sprite].fdir = Slot.read("sprite" + Cube[i].sprite + "fdir" , 0);
		}
	}
	ZFactor = Slot.read("ZFac", .75);

	LoadTheTileset(".." + temp5 + "tilesets" + temp5 +MapObject.Tileset);

	for (i=0; i<10; i++)
	{
	Sprite[i].zadd = 0;
	Sprite[i].xadd = 0;
	Sprite[i].yadd = 0;
	}

//Set up the Pxyz array
GetPxyz();
ResetPaths();
	if (name == undefined)
	{
	MapEditor();
	}
}

function LoadAnimationInfo(file)
{
var temp5 = CreateStringFromCode(47);
var Slot3 = OpenFile(".." + temp5 + "maps" + temp5 + file + ".mai");

	for (i=0; i<MaxAnimations; i++)
	{
		if (Slot3.read("Animation" + i + "_0",-1) >= 1)
		{
			for (j=0; j<=Slot3.read("Animation" + i + "_0",-1); j++)
			{
			AnimatedTile[i][j] = Slot3.read("Animation" + i + "_" + j,-1);
			}
		}
		else
		{
		break;
		}
	}

	for (i=0; i<MaxAnimatedTiles; i++)
	{
		if (Slot3.read("ATile" + i + "cube",-1) >= 0)
		{
			ATile[i].cube = Slot3.read("ATile" + i + "cube",-1);
			ATile[i].anim = Slot3.read("ATile" + i + "anim",-1);
			ATile[i].side = Slot3.read("ATile" + i + "side",-1);
			ATile[i].frame = Slot3.read("ATile" + i + "frame",-1);
		}
		else
		{
		ATile[i].cube = -1;
		break;
		}
	}
}

function AddFrame(sprite)
{
	if (Sprite[sprite].advance == undefined || Sprite[sprite].advance == true)
	{
		Sprite[sprite].frame++;
	
		if (Sprite[sprite].frame > SpriteSet[Sprite[sprite].spriteset][Sprite[sprite].direction][0])
		{
		Sprite[sprite].frame = 1;
		}
	}
}

function AddTileFrame(tile)
{
/*
AnimatedTile[0][0] = number of frames in the animation. (n)
AnimatedTile[0][1] = index of the first picture
AnimatedTile[0][2] = index of the second picture
AnimatedTile[0][..] = ..
AnimatedTile[0][n] = the last picture index


AnimatedTile[0].cube = the cube this animation runs on
AnimatedTile[0].side = the side of the cubes this animation runs on
AnimatedTile[0].frame = the current frame of the animation
*/

	if (ATile[tile].frame < AnimatedTile[ATile[tile].anim][0])
	{
	ATile[tile].frame++;
	}
	else
	{
	ATile[tile].frame = 1;
	}
	Cube[ATile[tile].cube]["pic" + ATile[tile].side] = AnimatedTile[ATile[tile].anim][ATile[tile].frame];
}


function AddFrameAll()
{
	for (afa = 0; afa <MaxSprites; afa++)
	{
		AddFrame(afa);
	}
	for (afa = 0; afa < MaxAnimatedTiles; afa++)
	{
		if (ATile[afa].cube >= 0)
		{
		AddTileFrame(afa);
		}
	}
}

function DrawMap()
{
var temp_layer = -10;
var temp_draw = 0;

/*	if (Frames/FrameUpdateRate == Math.floor(Frames/FrameUpdateRate))
	{ 
	AddFrameAll();
	}
*/
	if (CDirR == true)
	{
		for (i=0; i<CubeNumber; i++)
		{
			DrawCube(Draw[i][CDir+"r"], i);
		}
	}
	else
	{
		for (i=0; i<CubeNumber; i++)
		{
			DrawCube(Draw[i][CDir], i);
		}
	}
}

function CenterCamera(x,y,z)
{
var tempy_x = (ModX_x*x + ModY_x*y)*TileSize;
var tempy_y = (ModX_y*x + ModY_y*y + ModZ_y*z)*TileSize;

CameraX = tempy_x - GetScreenWidth()/2;
CameraY = tempy_y - GetScreenHeight()/2;
}

function CenterCameraCube(thecube)
{
var tempy_x = (ModX_x*(Cube[thecube].x+.5) + ModY_x*(Cube[thecube].y+.5))*TileSize;
var tempy_y = (ModX_y*(Cube[thecube].x+.5) + ModY_y*(Cube[thecube].y+.5) + ModZ_y*(Cube[thecube].z + Cube[thecube].height))*TileSize;

CameraX = tempy_x - GetScreenWidth()/2;
CameraY = tempy_y - GetScreenHeight()/2;
}



/*These functions do the opposite of the above.  Although finding
a 3d point from the screen won't result in a unique point, we find
a single point for this assuming that the y value of the 3d point is
one.*/
function GetYPointCenter(x,y)
{
return(1);
}

function GetXPointCenter(x,y)
{
return(tempX = ((x+CameraX)/TileSize-ModY_x)/ModX_x);
}

function GetZPointCenter(x,y)
{
var tempX = ((x+CameraX)/TileSize-ModY_x)/ModX_x;
return(tempZ = ((y+CameraY)/TileSize-ModY_y - ModX_y*tempX)/ModZ_y);
}

function GetPxyz()
{
	for (e1 = -10; e1<11; e1++)
	{
		for (e2 = -10; e2<11; e2++)
		{
			for (e3 = -10; e3<11; e3++)
			{
			Pxyz[e1][e2][e3] = undefined;
			}
		}
	}
	
	for (i=0; i<CubeNumber;i++)//number of cubes
	{
		if (Cube[i].pic1 > 0)
		{
		Pxyz[Cube[i].x][Cube[i].y][Cube[i].z] = i;
		}
	}
}

var PxyzHeightCube = -1;

function PxyzHeight(x,y,z,x1,y1,sp)
{
/*
This function looks at a cube at x,y,z, and looks at the cubes with their_x = x+x1, and their_y = y+1
and sees which cube in that stack is closest to the z of the origional x,y,z cube.  It then returns the
cube that is the closest.
*/

	if (sp == undefined)
		sp = 0;

var temp = 22;

	if (Pxyz[x][y][z] >= 0 )
	{
	}
	else
	{
		return(undefined);
	}

//Debugging

	for (i = 0.0; i<22; i+=.5)
	{

		if (Pxyz[x+x1][y+y1][z+i] >=0)
		{
			if (Cube[Pxyz[x+x1][y+y1][z+i]].pic1 != undefined/* && Cube[Pxyz[x+x1][y+y1][z+i]].decal == false */&& Math.abs(Cube[Pxyz[x][y][z]].height - i - Cube[Pxyz[x+x1][y+y1][z+i]].height) < temp)
			{
				if (Cube[Pxyz[x+x1][y+y1][z+i]].sprite >= sp)
				{
					return(undefined);
				}
			PxyzHeightCube = Pxyz[x+x1][y+y1][z+i];
			return(z + Cube[Pxyz[x][y][z]].height - Cube[Pxyz[x+x1][y+y1][z+i]].z - Cube[Pxyz[x+x1][y+y1][z+i]].height);
			}
		}
		else if (Pxyz[x+x1][y+y1][z-i] >=0)
		{
			if (Cube[Pxyz[x+x1][y+y1][z-i]].pic1!= undefined/* && Cube[Pxyz[x+x1][y+y1][z-i]].decal == false */&& z + Cube[Pxyz[x][y][z]].height - Cube[Pxyz[x+x1][y+y1][z-i]].z - Cube[Pxyz[x+x1][y+y1][z-i]].height < temp)
			{
				if (Cube[Pxyz[x+x1][y+y1][z-i]].sprite >= sp)
				{
				return(undefined);
				}
			PxyzHeightCube = Pxyz[x+x1][y+y1][z-i];
			return(z + Cube[Pxyz[x][y][z]].height - Cube[Pxyz[x+x1][y+y1][z-i]].z - Cube[Pxyz[x+x1][y+y1][z-i]].height);
			}
		}
	}
return(undefined);
}

/*
>>Pxyz array now only accounts for cubes which have a pic1 (top face).

-Add in shading for cubes

-Add Spriteset info as a .sav file
?-Would adding in a square draw order rather than a cube one increase the framerate?
-Add in pratical map functions
*/